// src/components/commons/Form/FormProvider.tsx
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _object_destructuring_empty(o) {
    if (o === null || o === void 0) throw new TypeError("Cannot destructure " + o);
    return o;
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);
    if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);
        if (enumerableOnly) {
            symbols = symbols.filter(function(sym) {
                return Object.getOwnPropertyDescriptor(object, sym).enumerable;
            });
        }
        keys.push.apply(keys, symbols);
    }
    return keys;
}
function _object_spread_props(target, source) {
    source = source != null ? source : {};
    if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
        ownKeys(Object(source)).forEach(function(key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
    }
    return target;
}
function _object_without_properties(source, excluded) {
    if (source == null) return {};
    var target = _object_without_properties_loose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _object_without_properties_loose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
import { createContext, useState } from "react";
import { jsx } from "react/jsx-runtime";
var FormContext = createContext(null);
var FormContextProvider = function(param) {
    var children = param.children;
    var _useState = _sliced_to_array(useState({}), 2), data = _useState[0], setData = _useState[1];
    var updateData = function(data2) {
        setData(_object_spread({}, data2));
    };
    var resetData = function() {
        return updateData({});
    };
    return /* @__PURE__ */ jsx(FormContext.Provider, {
        value: {
            data: data,
            updateData: updateData,
            resetData: resetData
        },
        children: children
    });
};
var FormProvider_default = FormContextProvider;
// src/components/commons/Form/FormView.tsx
import { useState as useState3, useEffect as useEffect2 } from "react";
// src/components/commons/InputError.tsx
import { jsx as jsx2 } from "react/jsx-runtime";
function Error2(param) {
    var error = param.error;
    return /* @__PURE__ */ jsx2("div", {
        className: "error",
        children: error
    });
}
var InputError_default = Error2;
// src/components/commons/Checkbox.tsx
import cx from "classnames";
import { jsx as jsx3, jsxs } from "react/jsx-runtime";
function Checkbox(_param) {
    var id = _param.id, checked = _param.checked, label = _param.label, onChange = _param.onChange, required = _param.required, error = _param.error, className = _param.className, style = _param.style, rest = _object_without_properties(_param, [
        "id",
        "checked",
        "label",
        "onChange",
        "required",
        "error",
        "className",
        "style"
    ]);
    return /* @__PURE__ */ jsxs("label", {
        "data-label": id,
        htmlFor: id,
        className: cx("field checkbox-field", id, className),
        style: style,
        children: [
            /* @__PURE__ */ jsx3("input", _object_spread_props(_object_spread({
                name: id,
                onChange: function(e) {
                    return onChange(e);
                },
                checked: checked
            }, rest), {
                type: "checkbox"
            })),
            /* @__PURE__ */ jsxs("span", {
                children: [
                    label,
                    required && /* @__PURE__ */ jsx3("span", {
                        className: "text-red ml-xs",
                        children: "*"
                    })
                ]
            }),
            error && /* @__PURE__ */ jsx3(InputError_default, {
                error: error
            })
        ]
    });
}
var Checkbox_default = Checkbox;
// src/components/commons/InputField.tsx
import cx2 from "classnames";
import { jsx as jsx4, jsxs as jsxs2 } from "react/jsx-runtime";
function InputField(_param) {
    var id = _param.id, label = _param.label, value = _param.value, _param_type = _param.type, type = _param_type === void 0 ? "text" : _param_type, required = _param.required, onChange = _param.onChange, error = _param.error, style = _param.style, className = _param.className, rest = _object_without_properties(_param, [
        "id",
        "label",
        "value",
        "type",
        "required",
        "onChange",
        "error",
        "style",
        "className"
    ]);
    console.log("id", id);
    return /* @__PURE__ */ jsxs2("label", {
        "data-label": id,
        htmlFor: id,
        className: cx2("field input-field", id, className),
        style: style,
        children: [
            /* @__PURE__ */ jsxs2("span", {
                children: [
                    label,
                    required && /* @__PURE__ */ jsx4("span", {
                        className: "text-red ml-xs",
                        children: "*"
                    })
                ]
            }),
            /* @__PURE__ */ jsx4("input", _object_spread({
                type: type,
                name: id,
                value: value,
                onChange: function(e) {
                    return onChange(e);
                },
                "data-valid": !error
            }, rest)),
            error && /* @__PURE__ */ jsx4(InputError_default, {
                error: error
            })
        ]
    });
}
var InputField_default = InputField;
// src/components/commons/RadioButton.tsx
import cx3 from "classnames";
import { jsx as jsx5, jsxs as jsxs3 } from "react/jsx-runtime";
function RadioButton(_param) {
    var id = _param.id, label = _param.label, _param_options = _param.options, options = _param_options === void 0 ? [] : _param_options, onChange = _param.onChange, error = _param.error, required = _param.required, style = _param.style, className = _param.className, rest = _object_without_properties(_param, [
        "id",
        "label",
        "options",
        "onChange",
        "error",
        "required",
        "style",
        "className"
    ]);
    var renderRadioButtons = function(options2) {
        return options2.map(function(option) {
            return /* @__PURE__ */ jsxs3("span", {
                children: [
                    /* @__PURE__ */ jsx5("input", _object_spread({
                        name: id,
                        id: option,
                        value: option,
                        onChange: function(e) {
                            return onChange(e);
                        }
                    }, rest)),
                    /* @__PURE__ */ jsx5("span", {
                        className: "ml-xs",
                        children: option
                    })
                ]
            }, option);
        });
    };
    return /* @__PURE__ */ jsxs3("label", {
        "data-label": id,
        htmlFor: id,
        className: cx3("field radiobutton-field", id, className),
        style: style,
        children: [
            /* @__PURE__ */ jsxs3("span", {
                children: [
                    label,
                    required && /* @__PURE__ */ jsx5("span", {
                        className: "text-red ml-xs",
                        children: "*"
                    })
                ]
            }),
            renderRadioButtons(options),
            error && /* @__PURE__ */ jsx5(InputError_default, {
                error: error
            })
        ]
    });
}
var RadioButton_default = RadioButton;
// src/components/commons/Form/FormContext.ts
import { useContext } from "react";
var useFormContext = function() {
    var context = useContext(FormContext);
    if (!context) {
        throw new Error("useFormContext must be used within a FormContextProvider");
    }
    return context;
};
// src/components/commons/Button.tsx
import cx4 from "classnames";
// src/components/commons/TextToHTML.tsx
import { jsx as jsx6 } from "react/jsx-runtime";
function TextToHTML(param) {
    var text = param.text;
    return /* @__PURE__ */ jsx6("span", {
        dangerouslySetInnerHTML: {
            __html: text
        }
    });
}
var TextToHTML_default = TextToHTML;
// src/components/commons/Button.tsx
import { jsx as jsx7 } from "react/jsx-runtime";
function Button(_param) {
    var id = _param.id, className = _param.className, value = _param.value, props = _object_without_properties(_param, [
        "id",
        "className",
        "value"
    ]);
    return /* @__PURE__ */ jsx7("button", _object_spread_props(_object_spread({
        className: cx4(id, className)
    }, props), {
        children: /* @__PURE__ */ jsx7(TextToHTML_default, {
            text: value
        })
    }));
}
var Button_default = Button;
// src/components/commons/Form/@enums.ts
var TextInputTypeList = [
    "text",
    "email",
    "date",
    "time",
    "datetime-local",
    "password",
    "color",
    "file"
];
var AllInputTypeList = [
    "text",
    "email",
    "date",
    "time",
    "datetime-local",
    "password",
    "color",
    "file",
    "dropdown",
    "radio",
    "checkbox"
];
// src/components/commons/Form/FormView.tsx
import cx6 from "classnames";
// src/components/commons/Dropdown.tsx
import { useEffect, useRef, useState as useState2 } from "react";
import cx5 from "classnames";
import { jsx as jsx8, jsxs as jsxs4 } from "react/jsx-runtime";
function Dropdown(_param) {
    var id = _param.id, value = _param.value, options = _param.options, error = _param.error, label = _param.label, style = _param.style, className = _param.className, required = _param.required, disabled = _param.disabled, onSelect = _param.onSelect, _param_emptyText = _param.emptyText, emptyText = _param_emptyText === void 0 ? "Select an option" : _param_emptyText, rest = _object_without_properties(_param, [
        "id",
        "value",
        "options",
        "error",
        "label",
        "style",
        "className",
        "required",
        "disabled",
        "onSelect",
        "emptyText"
    ]);
    var _useState2 = _sliced_to_array(useState2(false), 2), isOpen = _useState2[0], setIsOpen = _useState2[1];
    var dropdownRef = useRef(null);
    var handleOnSelect = function(option) {
        onSelect(option);
    };
    useEffect(function() {
        var handleClickOutside = function(event) {
            if (dropdownRef.current && !dropdownRef.current.contains(event.target)) {
                setIsOpen(false);
            }
        };
        document.addEventListener("mousedown", handleClickOutside);
        return function() {
            document.removeEventListener("mousedown", handleClickOutside);
        };
    }, []);
    return /* @__PURE__ */ jsxs4("label", {
        ref: dropdownRef,
        "data-label": id,
        htmlFor: id,
        className: cx5("field dropdown", id, className),
        style: style,
        children: [
            /* @__PURE__ */ jsxs4("span", {
                children: [
                    label,
                    required && /* @__PURE__ */ jsx8("span", {
                        className: "text-red ml-xs",
                        children: "*"
                    })
                ]
            }),
            /* @__PURE__ */ jsxs4("div", _object_spread_props(_object_spread({
                className: "dropdown-container"
            }, rest), {
                "data-opened": isOpen,
                children: [
                    /* @__PURE__ */ jsx8("button", {
                        type: "button",
                        className: "dropdown-toggle",
                        disabled: disabled,
                        onClick: function(e) {
                            setIsOpen(!isOpen);
                        },
                        children: value || emptyText
                    }),
                    isOpen && /* @__PURE__ */ jsxs4("ul", {
                        className: "dropdown-menu",
                        children: [
                            /* @__PURE__ */ jsx8("li", {
                                onClick: function(e) {
                                    return handleOnSelect("");
                                },
                                children: emptyText
                            }, -1),
                            options.map(function(option, index) {
                                return /* @__PURE__ */ jsx8("li", {
                                    onClick: function() {
                                        return handleOnSelect(option);
                                    },
                                    children: option
                                }, index);
                            })
                        ]
                    })
                ]
            })),
            error && /* @__PURE__ */ jsx8(InputError_default, {
                error: error
            })
        ]
    });
}
var Dropdown_default = Dropdown;
// src/utils/uitls.ts
function isEmptyObject(obj) {
    return obj && Object.keys(obj).length <= 0;
}
var validateFields = function(type, value, required, validator) {
    var error = "";
    var valid = true;
    if (required && (value.length === 0 || type === "checkbox" && value === "false")) {
        valid = false;
        error = "Required Field";
    }
    if (valid && validator) {
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = validator[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var _step_value = _step.value, validate = _step_value.validate, message = _step_value.message;
                if (validate(value)) {
                    valid = false;
                    error = message;
                    break;
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
    }
    return [
        valid,
        error
    ];
};
// src/components/commons/Form/FormView.tsx
import { jsx as jsx9 } from "react/jsx-runtime";
import { createElement } from "react";
function FormView(_param) {
    var id = _param.id, className = _param.className, formSpecs = _param.formSpecs, method = _param.method, onSubmit = _param.onSubmit, rest = _object_without_properties(_param, [
        "id",
        "className",
        "formSpecs",
        "method",
        "onSubmit"
    ]);
    var _useFormContext = useFormContext(), data = _useFormContext.data, updateData = _useFormContext.updateData, resetData = _useFormContext.resetData;
    var _useState3 = _sliced_to_array(useState3(false), 2), showValidationMessage = _useState3[0], setShowValidationMessage = _useState3[1];
    useEffect2(function() {
        if (isEmptyObject(data)) {
            var defineState = function(fields) {
                var initState = {};
                fields.forEach(function(field) {
                    if (initState[field.id]) {
                        throw new Error("Duplicate form field found. Each form field need to have unique id. Duplicate field - ".concat(field.id));
                    }
                    if (AllInputTypeList.includes(field.type)) {
                        var validator = "validator" in field && field.validator ? field.validator : [];
                        var required = "required" in field && field.required ? field.required : false;
                        var val = "value" in field && field.value ? field.value : "";
                        if (field.type === "checkbox") {
                            val = field.checked ? field.checked.toString() : "false";
                        }
                        var _validateFields = _sliced_to_array(validateFields(field.type, val, required, validator), 2), isValid = _validateFields[0], error = _validateFields[1];
                        initState[field.id] = {
                            value: val,
                            valid: isValid,
                            error: error
                        };
                    }
                    if (field.type === "row-layout" || field.type === "col-layout") {
                        var innerState = defineState(field.fields);
                        initState = _object_spread({}, initState, innerState);
                    }
                });
                return initState;
            };
            var initData = defineState(formSpecs({
                data: data,
                updateData: updateData,
                resetData: resetData
            }));
            console.log(initData);
            updateData(initData);
        }
    }, [
        data
    ]);
    var renderInputField = function(_param) {
        var rest2 = _extends({}, _object_destructuring_empty(_param));
        var id2 = rest2.id;
        var type = rest2.type;
        var handleInputOnChange = function(type2, value, required, validator) {
            data[id2].value = value;
            var _validateFields = _sliced_to_array(validateFields(type2, value, required, validator), 2), isValid = _validateFields[0], error = _validateFields[1];
            updateData(_object_spread_props(_object_spread({}, data), _define_property({}, id2, {
                value: value,
                valid: isValid,
                error: error
            })));
        };
        if (type === "checkbox") {
            var checkBoxRest = rest2;
            return /* @__PURE__ */ createElement(Checkbox_default, _object_spread_props(_object_spread({}, checkBoxRest), {
                onChange: function(e) {
                    handleInputOnChange(type, e.target.checked.toString(), checkBoxRest.required);
                    checkBoxRest.onChange && checkBoxRest.onChange(e);
                },
                error: showValidationMessage ? data[id2].error : "",
                key: id2,
                checked: data[id2].value === "true"
            }));
        } else if (type === "radio") {
            var radioButtonRest = rest2;
            return /* @__PURE__ */ jsx9(RadioButton_default, _object_spread_props(_object_spread({}, radioButtonRest), {
                onChange: function(e) {
                    handleInputOnChange(type, e.target.value, radioButtonRest.required);
                    radioButtonRest.onChange && radioButtonRest.onChange(e);
                },
                error: showValidationMessage ? data[id2].error : ""
            }));
        } else if (type === "button") {
            return /* @__PURE__ */ jsx9(Button_default, _object_spread({}, rest2), id2);
        } else if (type === "submit") {
            return /* @__PURE__ */ jsx9(Button_default, _object_spread({}, rest2), id2);
        } else if (type === "dropdown") {
            var dropDownRest = rest2;
            return /* @__PURE__ */ jsx9(Dropdown_default, _object_spread({
                value: data[id2].value,
                onSelect: function(option) {
                    handleInputOnChange(type, option, dropDownRest.required);
                    dropDownRest.onSelect && dropDownRest.onSelect(option);
                },
                error: showValidationMessage ? data[id2].error : ""
            }, dropDownRest), id2);
        } else if (TextInputTypeList.includes(type)) {
            var inputFieldRest = rest2;
            return /* @__PURE__ */ createElement(InputField_default, _object_spread_props(_object_spread({}, inputFieldRest), {
                value: data[id2].value,
                error: showValidationMessage ? data[id2].error : "",
                key: id2,
                onChange: function(e) {
                    handleInputOnChange(type, e.target.value, inputFieldRest.required, inputFieldRest.validator);
                    inputFieldRest.onChange && inputFieldRest.onChange(e);
                }
            }));
        } else {
            return null;
        }
    };
    var handleSubmit = function(e) {
        e.preventDefault();
        if (!showValidationMessage) {
            setShowValidationMessage(true);
        }
        onSubmit(Object.values(data).every(function(value) {
            return value.valid;
        }), data);
    };
    var renderFields = function(fields) {
        var formFields = fields.map(function(field) {
            var type = field.type, id2 = field.id, rest2 = _object_without_properties(field, [
                "type",
                "id"
            ]);
            if (type === "col-layout") {
                var fields2 = rest2.fields, className2 = rest2.className, restcol = _object_without_properties(rest2, [
                    "fields",
                    "className"
                ]);
                return /* @__PURE__ */ jsx9("div", _object_spread_props(_object_spread({}, restcol), {
                    className: cx6("layout row", id2, className2),
                    children: renderFields(fields2)
                }), id2);
            }
            if (type === "row-layout") {
                var fields21 = rest2.fields, className21 = rest2.className, restrow = _object_without_properties(rest2, [
                    "fields",
                    "className"
                ]);
                return /* @__PURE__ */ jsx9("div", _object_spread_props(_object_spread({}, restrow), {
                    className: cx6("layout col", id2, className21),
                    children: renderFields(fields21)
                }), id2);
            }
            return renderInputField(field);
        });
        return formFields;
    };
    return /* @__PURE__ */ jsx9("form", _object_spread_props(_object_spread({
        className: cx6(id, className),
        id: id,
        method: method,
        onSubmit: handleSubmit
    }, rest), {
        children: /* @__PURE__ */ jsx9("div", {
            className: "flex flex-wrap",
            children: !isEmptyObject(data) && renderFields(formSpecs({
                data: data,
                updateData: updateData,
                resetData: resetData
            }))
        })
    }));
}
var FormView_default = FormView;
// src/components/commons/Form/Form.tsx
import { jsx as jsx10 } from "react/jsx-runtime";
function Form(props) {
    return /* @__PURE__ */ jsx10(FormProvider_default, {
        children: /* @__PURE__ */ jsx10(FormView_default, _object_spread({}, props))
    });
}
var Form_default = Form;
export { Form_default as Form };
